<body>
<pre>

<b>Example of dynamic attribute expression:</b>

CoolingWaterFlow=DevDouble(reg(0x3000)/10.0*1.666)
CavityWaterFlow=DevDouble(reg(0x3001)/10.0*1.46)
CavityWaterOutTemp=DevDouble(reg(0x300A)/10.0)
CavityWaterInTemp=DevDouble(reg(0x3010)/10.0)
TemperatureItlk1=DevBoolean(not flag(0x3031,9))
TemperatureItlk2=DevBoolean(not flag(0x3031,10))
BlowerOnOff=DevShort(reg(0x3029),WriteInt(0x3029,VALUE))
Temp_Threshold=DevDouble(reg(0x3080)/10.0,WriteInt(0x3080,VALUE/10.0))
CalcPower=DevDouble((4.18/60.0)*CoolingWaterFlow*(CavityWaterOutTemp-CavityWaterInTemp))
Circumference=DevDouble(992/xattr('sy/ms/1/frequency')*299792458)
Reset_All=DevShort( coil(3) | coil(4) | coil(5) , WriteCoils({3,4,5},VALUE))
SwapBits=DevShort(coil(0),WriteCoils({0,1},{VALUE,not VALUE}))

<b>Exemple of dynamic command expression:</b>

Reset=WriteInt(0x3029,reg(0x3029)|0x0100)
On=WriteInt(0x3029,reg(0x3029)|0x0010)
Off=WriteInt(0x3029,reg(0x3029)&~0x0010)
Reset=WriteBit(0x3029,12,1)

<b>Exemple of state definition:</b>

FAULT=not Flag(0x3031,7),Depression air flow
ALARM=CoolingWaterFlow&lt;213,Flow too low
ALARM=CavityWaterOutTemp&gt;23.4,Temp too high
ON=Flag(0x3031,13),Blower is ON

First states in the above list have a highest priority.

<b>Grammar</b>

 &lt;attdef&gt; ::= &lt;name&gt; '=' &lt;type&gt;'(' &lt;expr&gt; [, &lt;writefn&gt;'('&lt;writefn_params&gt;,&lt;expr&gt;')']')' |
              &lt;name&gt; '= DevString(' &lt;integer&gt;,&lt;integer&gt; ')'
 &lt;statedef&gt; ::= &lt;name&gt; '=' &lt;expr&gt; [, &lt;status_string&gt;]                          
                                                                               
 &lt;expr&gt;   ::= &lt;factor1&gt; [ &lt;oper1&gt; &lt;factor1&gt; ]                                  
 &lt;factor1&gt;::= &lt;factor2&gt; [ &lt;oper2&gt; &lt;factor2&gt; ]                                  
 &lt;factor2&gt;::= &lt;factor3&gt; [ &lt;oper3&gt; &lt;factor3&gt; ]                                  
 &lt;factor3&gt;::= &lt;factor4&gt; [ &lt;oper4&gt; &lt;factor4&gt; ]*                                 
 &lt;factor4&gt;::= &lt;term&gt; [ &lt;oper5&gt; &lt;term&gt; ]*                                       
                                                                               
 &lt;term&gt;   ::= '(' &lt;exp&gt; ')'      |                                             
                &lt;double&gt;         |
                &lt;name&gt;           |
               '-' &lt;term&gt;        |                                             
               '~' &lt;term&gt;        |                                             
               'not ' &lt;term&gt;     |                                             
               'sin(' &lt;exp&gt; ')'  |                                             
               'cos(' &lt;exp&gt; ')'  |                                             
               'tan(' &lt;exp&gt; ')'  |                                             
               'asin(' &lt;exp&gt; ')' |                                             
               'acos(' &lt;exp&gt; ')' |                                             
               'atan(' &lt;exp&gt; ')' |                                             
               'abs(' &lt;exp&gt; ')'  |                                             
               'sinh(' &lt;exp&gt; ')' |                                             
               'cosh(' &lt;exp&gt; ')' |                                             
               'tanh(' &lt;exp&gt; ')' |                                             
               'exp(' &lt;exp&gt; ')'  |                                             
               'ln(' &lt;exp&gt; ')'   |                                             
               'log(' &lt;exp&gt; ')'  |                                             
               'inv(' &lt;exp&gt; ')'  |                                             
               'sqrt(' &lt;exp&gt; ')' |                                             
               'fact(' &lt;exp&gt; ')'  |                                            
               'pow(' &lt;exp&gt;,&lt;exp&gt; ')'  |                                       
               '{' &lt;exp&gt;,[&lt;exp&gt;]* '}' |                    // Vector definition
               'mod(' &lt;exp&gt;,&lt;exp&gt; ')'  |                         // Modulo
               'sum(' &lt;string&gt;,&lt;integer&gt;,&lt;integer&gt; ')' |   // Sum of variable from name(i1) to name(i2)

                                                      //Scalar reading:          
               'reg(' &lt;integer&gt; ')' |                 //Read 16 bit signed       
               'ureg(' &lt;integer&gt; ')' |                //Read 16 bit unsigned     
               'freg(' &lt;integer&gt; ')' |                //Read 2*16bit float LE
               'fregsbe(' &lt;integer&gt;,&lt;integer&gt; ')' |   Read n*2*16bit float BE
               'dreg(' &lt;integer&gt; ')' |                //Read 4*16bit double LE
               'dregbe(' &lt;integer&gt; ')' |                //Read 4*16bit double BE
               'coil(' &lt;integer&gt; ')' |                //Read single coil
               'flag(' &lt;integer&gt;,&lt;integer&gt; ')' |      //Read bit n of reg (return 1 or 0)
                                                                               
                                                      //Vector reading:          
               'regs(' &lt;integer&gt;,&lt;integer&gt; ')' |      //Read n*16 bit signed     
               'uregs(' &lt;integer&gt;,&lt;integer&gt; ')' |     //Read n*16 bit unsigned
               'fregs(' &lt;integer&gt;,&lt;integer&gt; ')' |     //Read n*2*16bit float LE
               'fregsbe(' &lt;integer&gt;,&lt;integer&gt; ')' |     //Read n*2*16bit float BE
               'dregs(' &lt;integer&gt;,&lt;integer&gt; ')' |     //Read n*4*16bit double LE
               'dregsbe(' &lt;integer&gt;,&lt;integer&gt; ')' |     //Read n*4*16bit double BE
               'coils(' &lt;integer&gt;,&lt;integer&gt; ')' |     //Read n*coils
               'PI'
                                                                               
 &lt;oper1&gt;    ::= '&' | '|' | '^'                       //lowest precedence     
 &lt;oper2&gt;    ::= '<' | '>' | '>=' | '<=' | '==' | '!='                          
 &lt;oper3&gt;    ::= '<<' | '>>'                                                    
 &lt;oper4&gt;    ::= '+' | '-'                                                      
 &lt;oper5&gt;    ::= '*' | '/'                             //highest precedence    
                                                                               
 &lt;writefn&gt;  ::= 'WriteInt' |       //Write 16 bit registers (signed)
                'WriteUInt' |      //Write 16 bit registers (unsigned)
                'WriteLong' |      //Write 2*16 bit registers (signed)
                'WriteBit' |       //Write bit of a 16 bit register (Thread Safe) params=adress,bitindex
                'WriteULong' |     //Write 2*16 bit registers (unsigned)
                'WriteLongLSB' |   //Write 2*16 bit registers (signed lsb first)
                'WriteULongLSB' |  //Write 2*16 bit registers (unsigned lsb first)
                'WriteFloat' |     //Write float value in 2 consecutive regs
                'WriteDouble' |    //Write double value in 4 consecutive regs
                'WriteCoil' |      //Write single coil
                'WriteCoils'       //Write multiple coils params={coillist}

 &lt;writefn_params&gt; ::= &lt;integer&gt; |
                      &lt;integer&gt;,&lt;integer&gt; |            // For WriteBit
                      '{' &lt;integer&gt;,[&lt;integer&gt;]* '}'   // Integer list for WriteCoils

 &lt;type&gt;     ::= 'DevBoolean' | 'DevShort' | 'DevDouble' | 'DevLong' |  'DevFloat' |
                'DevVarDoubleArray' | 'DevUShort' | 'DevULong'                                                
                                                                               
 &lt;double&gt;   ::= &lt;nb&gt;* '.' &lt;nb&gt; &lt;nb&gt;* ['E' [-] &lt;nb&gt; &lt;nb&gt;*] | &lt;integer&gt;          
 &lt;integer&gt;  ::= ['0x']&lt;nb&gt;*                                                    
 &lt;nb&gt;       ::= '0'..'9'                                                       
 &lt;name&gt;     ::= &lt;letter&gt;[&lt;letter&gt; | &lt;nb&gt;]*                                     
 &lt;letter&gt;   ::= 'A'..'Z' | 'a'..'z' | '_'                                      
</pre>
</body>

